#http://hydrosheds.cr.usgs.gov/datadownload.php?reqdata=30bass
# http://bcube.geodab.eu/bcube-broker/services/opensearchsemanticenhanced?&reqID=npzmhOwDsB4bbF3UZ9EUPQ1R9b3ViTIV&class=&subj=&relt=&si=1&st=&gdc=&loc=&radio_group=on&bbox=-180,-80,180,90&relation_radio_group=on&rel=contains&ts=&te=&trel=&ct=10&outputFormat=application%2Fatom%2Bxml&qic=&tccrv=&dcrv=&lipr=&lisr=&rat=&repasp=&q=&usrd=&uselim=&lac=&luc=&other=&evtOrd=Time&minmag=&maxmag=&magt=&mind=&maxd=&sta=&sensor=&inpe-sat-name=&inpe-instr-name=&sources=UUID-b6e217f2-e2e1-4a1a-b0d0-069cd0622f24&parents=&rela=&input-rela-select-name=skos%3Abroader
# http://gradlab4.bse.vt.edu:8080/gi-axe-11.0.5-0522/services/wcs?protocol=OPeNDAP&linkage=http://gradlab4.bse.vt.edu:8080/thredds/dodsC/landuse/nlcd/nlcd_us_conus_imgn39w080_13nc4.nc?&name=Band1&SERVICE=WCS&VERSION=1.0.0

import urllib2
import xml.dom.minidom
from xml.dom.minidom import parse
import arcpy
import time
import sys
arcpy.env.overwriteOutput = True
arcpy.env.tileSize = "4096 4096"

# Check out any necessary licenses
try:
    if arcpy.CheckExtension("spatial") == "Available":
        arcpy.CheckOutExtension("spatial")
except:
    print "Spatial Analyst license is not available"
    sys.exit(0)
    
# Set Geoprocessing environments
arcpy.env.cartographicCoordinateSystem = ""

# Gumara River, Ethiopia
clat=11.3999226
clon=37.7005879
# Factory Brook, NY, USA
clat=42.6652
clon=-76.21
# Factory Brook, NY, USA
clat=42.6652
clon=-76.21
# Reisle Texas, USA
clat=31.4739822
clon=-96.8839965
# Ecuador, Rio Bamba
clat=-1.666
clon=-78.657
# Shenandoah River, USA
clat=38.30
clon=-78.89
# Columbia, 
clat=38.30
clon=-78.89
extent=1.5/2

mxd=arcpy.mapping.MapDocument("CURRENT")
ProjectFolder=mxd.filePath.rsplit("\\",1)[0]
df= arcpy.mapping.ListDataFrames(mxd)[0]
#clat= float(sys.argv[1])
#clon= float(sys.argv[2])
#extent = float(sys.argv[3])
demselectlist =sys.argv[1]

dfExtentLL=df.extent.projectAs("WGS 1984")
clon=(dfExtentLL.XMax-dfExtentLL.XMin)/2.0+dfExtentLL.XMin
clat=(dfExtentLL.YMax-dfExtentLL.YMin)/2.0+dfExtentLL.YMin
extent=dfExtentLL.width/2.0

# Global_SRTMv_3.003; Global_USGS_ASTGTM002; US_NED_10m; US_NED_30m; US_NED_3m
demselect=demselectlist.split(';', 1)[0]
urlbase="http://gradlab4.bse.vt.edu:8080/gi-cat-10.0.2/"
if demselect == "Global_SRTMv_3.003":
  UUID="UUID-9c6ecae6-81b4-41b4-b2a1-352f2f249377"
  ProdName="SRTM" 
  urlbase="http://gradlab4.bse.vt.edu:8080/gi-cat-10.0.2/"
#  urlbase="http://bcube.geodab.eu/bcube-broker/"
elif demselect == "Global_USGS_ASTGTM002":
  UUID="UUID-23219c29-d529-4ffb-8e4a-92777a733ff4,UUID-530fb47f-3b11-4d03-af7d-c29daf5ae1ea"
  ProdName="ASTGTM2" 
  urlbase="http://gradlab4.bse.vt.edu:8080/gi-cat-10.0.2/"
elif demselect == "US_NED_10m":
  UUID="UUID-3e908b88-8788-4676-bc1e-e47b46e38763"
  ProdName="img" 
  urlbase="http://gradlab4.bse.vt.edu:8080/gi-cat-10.0.2/"
elif demselect == "US_NED_30m":
  UUID="UUID-188acf65-c8f7-4406-b859-f6434dcfc9ec"
  ProdName="img" 
  urlbase="http://gradlab4.bse.vt.edu:8080/gi-cat-10.0.2/"
else:
  arcpy.AddMessage("Nothing selected, defaulting to SRTM")
  UUID="UUID-9c6ecae6-81b4-41b4-b2a1-352f2f249377"
  ProdName="SRTM" 
  urlbase="http://gradlab4.bse.vt.edu:8080/gi-cat-10.0.2/"

arcpy.AddMessage("Dan " + ProjectFolder + " " + str(clat) +" " +  str(clon) + " " + str(extent) + " " + demselect)

BCubeFolder=ProjectFolder + "\\BCube"
publish=BCubeFolder+"\\publish.txt"
arcpy.AddMessage("Dan " + BCubeFolder)
arcpy.env.workspace=BCubeFolder
if not arcpy.Exists(BCubeFolder):
    arcpy.AddMessage("Building the BCube Folder")
    arcpy.CreateFolder_management(ProjectFolder, "BCube")

bbox=str(clon-extent)+","+str(clat-extent)+","+str(clon+extent)+","+str(clat+extent) 
bboxspace=str(clon-extent)+" "+str(clat-extent)+" "+str(clon+extent)+" "+str(clat+extent) 
url=urlbase+"/services/opensearchsemanticenhanced?&reqID=npzmhOwDsB4bbF3UZ9EUPQ1R9b3ViTIV&radio_group=on&bbox=" + bbox + "&relation_radio_group=on&rel=overlaps&ct=1000&outputFormat=application%2Fatom%2Bxml&evtOrd=Time&sources="+UUID
arcpy.AddMessage(url)
dom=xml.dom.minidom.parse(urllib2.urlopen(url))
Topic=dom.getElementsByTagName('entry')
for node in Topic:
  onlinelist=node.getElementsByTagName('gmd:onLine')
  for olnode in onlinelist:
    linklist=olnode.getElementsByTagName('gmd:URL')
    protlist=olnode.getElementsByTagName('gco:CharacterString')
    tlist=node.getElementsByTagName('title')
    i=0
    for a in linklist:
      protocol=protlist[i].firstChild.data
      if 'WebCoverageService' in protocol:
       if 'protocol=OPeNDAP' in a.firstChild.data:
        url= a.firstChild.data + "SERVICE=WCS&VERSION=1.0.0";
        arcpy.AddMessage(url)
        wcslayer=tlist[0].firstChild.data
        print wcslayer
        arcpy.AddMessage(wcslayer)
        result = None
        while result is None:
          try: 
            if ('SRTMv3_3_S5' not in str(wcslayer)):
              wcslayer=str(wcslayer).lower().translate(None,"_")
              arcpy.MakeWCSLayer_management(url,wcslayer,bboxspace) 
              arcpy.CopyRaster_management(wcslayer,BCubeFolder + "\\" + wcslayer.split(".")[0] + ".tif")
              for lyr in arcpy.mapping.ListLayers(mxd, "", df):
                if '.nc' in str(lyr):
                  print "Success on:" + str(lyr)
                  arcpy.mapping.RemoveLayer(df,lyr)
              with open(publish, "a") as myfile:
                myfile.write("Elevation\n")
                myfile.write(url + "\n")
                myfile.close()
            result = True
          except:
            for lyr in arcpy.mapping.ListLayers(mxd, "", df):
              if '.nc' in str(lyr):
                print "failed on:" + str(lyr)
                arcpy.mapping.RemoveLayer(df,lyr)
            pass
      i=i+1


arcpy.RefreshActiveView()
arcpy.RefreshCatalog(arcpy.env.workspace)
arcpy.RefreshTOC()
lprodname=ProdName.lower().translate(None,"_")

#mxd.save()
arcpy.RefreshCatalog(arcpy.env.workspace)
rlist=arcpy.ListRasters(lprodname + '*',"TIF")
# Build the odd formatted input string.
inRasters=""
for grid in rlist:
   thisGrid = arcpy.env.workspace+'/'+grid
   #print thisGrid
   if len(inRasters) == 0:
     inRasters = thisGrid
   else:
     inRasters = inRasters + ';' + thisGrid
inRasters='"'+inRasters+'"'
arcpy.AddMessage(lprodname + " " + ",".join(rlist) + " " + arcpy.env.workspace)
arcpy.AddMessage(inRasters)

arcpy.MosaicToNewRaster_management(inRasters,arcpy.env.workspace, lprodname + ".tif","#","32_BIT_FLOAT", "#", 1, "MAXIMUM", "FIRST")


bboxcl=str(clon-extent)+" "+str(clat-extent)+" "+str(clon+extent)+" "+str(clat+extent) 

#arcpy.BuildRasterAttributeTable_management(arcpy.env.workspace+"/"+lprodname+".tif")
arcpy.AddMessage(arcpy.env.workspace+"/"+lprodname+".tif" +" "+ lprodname + "cl.tif")
arcpy.Clip_management(arcpy.env.workspace+"/"+lprodname+".tif",bboxcl,arcpy.env.workspace+"/"+lprodname + "cl.tif", "#", "#", "NONE")

utmzone=str(math.trunc((180+clon)//6+1))
utmCM=str((float(utmzone)-0.5)*6-180.0)

if clat > 0:
  utmzone=utmzone + "N"
  hemi="Northern"
  northing="0.0"
else:
  utmzone=utmzone + "S"
  hemi="Southern"
  northing="10000000.0"

coordsys="Coordinate Systems/Projected Coordinate Systems/UTM/WGS 1984/"+hemi+" Hemisphere/WGS 1984 UTM Zone "+utmzone+".prj"
arcpy.AddMessage("CoordSys:"+coordsys)

Coordinate_System = "PROJCS['WGS_1984_UTM_Zone_"+utmzone+"',GEOGCS['GCS_WGS_1984',DATUM['D_WGS_1984',SPHEROID['WGS_1984',6378137.0,298.257223563]],PRIMEM['Greenwich',0.0],UNIT['Degree',0.0174532925199433]],PROJECTION['Transverse_Mercator'],PARAMETER['False_Easting',500000.0],PARAMETER['False_Northing',"+northing+"],PARAMETER['Central_Meridian',"+utmCM+"],PARAMETER['Scale_Factor',0.9996],PARAMETER['Latitude_Of_Origin',0.0],UNIT['Meter',1.0]]"

arcpy.AddMessage("CoordSysNew:"+Coordinate_System)

arcpy.ProjectRaster_management(arcpy.env.workspace+"/"+lprodname+"cl.tif",arcpy.env.workspace+"/"+lprodname+utmzone+".tif", Coordinate_System,"BILINEAR", "", "", "", "")

rasters = arcpy.ListRasters(arcpy.env.workspace+"/"+lprodname+utmzone + "*","TIF")
raster=arcpy.env.workspace+"/"+lprodname+utmzone+".tif"
arcpy.AddMessage("Adding "+raster)
arcpy.AddMessage(raster)
arcpy.AddMessage(arcpy.env.workspace)
arcpy.AddMessage(BCubeFolder)
addLayer = arcpy.mapping.Layer(raster)  
arcpy.mapping.AddLayer(df,addLayer)  
sr=arcpy.Describe(addLayer).spatialReference
arcpy.AddMessage("1dan")
df.spatialReference= sr
arcpy.RefreshActiveView()

